/* function prototypes */

#define PSEUDO
typedef unsigned int	   WORD;
typedef unsigned long	LONG;

/* eval.c */

int eval(long*);

int get_term(long*);

void exprinit(void);

void expreinit(void);


/* as.c */

void doflag(char *);

void make_pass(char *);

int getaline(FILE *);

int parse_line(void);

void process(void);


/* do.c */

void localinit(void);

void do_op(int, int, int);

long check (long, int);

int size76(void);

int size109(void);

int size109b(void);

int adreg(struct ea*);

int modreg(register struct ea*);

void finish(struct ea *);

int genxreg(struct ea *);

int getrlist(struct ea *);

WORD bitfld(struct ea*, int);

void dump_regs(void);

void do_opt(struct opts *);

void o_list(void);

void o_nolist(void);

void o_null(void);

int fsize(void);

void checkfclist(int, struct ea *);

void o_fpid(char*);

void o_round(void);

void o_prec(void);

int pmmu_fc(struct ea *);

struct opts {   /* a list of allowed options */
	char    *opt_name;
	void     (*opt_func)();
	};


/* emit.c */

void elong(long);

void eword(long);

void emit(WORD);

void f_record(void);

void print_line(void);


/* lookup.c */

                 
int hash(register char*);

void install(char*, long, char);

struct nlist* lookup(register char*);

struct mne * mne_look(char*);

void dump_syms(void);


/* match.c */


struct tmpl* tmpl_match(struct tmpl*, int);

int eamatch(int, int);

void scanea(register struct ea*);

void do_multi(void);

int optsize(long);

int optscale(void);

void do_indexed(struct ea*);

void do_xn(struct ea*);

void checkpair(struct ea*);

void checklist(struct ea*);

int regbit(int, int);

void oh_shit(struct ea*);

void dump_comp(void);

void dump_mne(void);

void psize(int);


/* srec.c */


void srecinit(char*);

void srecdata(int, LONG, char*);

void srecend(LONG);

void srec(char, int, LONG, char*);

void put2hex(long);
                 
/* util.c */


void fatal(char*);

void error(char*);

void serror(char*, char*);

void warn(char*);

int delim(char);

char* skip_white(char*);

int any(char, char*);

char mapdn(char);

WORD loword(long);

WORD hiword(long);

WORD lobyte(long);

WORD hibyte(long);

int head(char*, char*);

int alpha(char);

int alphan(char);

int white(char);

long reverse(long);

char* next_str(void);
